package xyz.fzorb.noThankYouMicrosoft;

import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.plugin.java.JavaPlugin;
import xyz.fzorb.noThankYouMicrosoft.flagFrontend.menuEvents;
import xyz.fzorb.noThankYouMicrosoft.flagFrontend.prideCommand;

import java.io.File;
import java.io.IOException;

public final class NoThankYouMicrosoft extends JavaPlugin {

    private static JavaPlugin instance;
    private static File databaseFile;
    private static YamlConfiguration databaseFileConfig;

    @Override
    public void onEnable() {
        instance = this;
        this.saveDefaultConfig();
        createDatabaseConfig();
        this.getServer().getPluginManager().registerEvents(new messageListener(), this);
        this.getServer().getPluginManager().registerEvents(new menuEvents(), this);
        this.getCommand("pride").setExecutor(new prideCommand());
    }

    private void createDatabaseConfig() {
        databaseFile = new File(getDataFolder(), "database.yml");
        if (!databaseFile.exists()) {
            databaseFile.getParentFile().mkdirs();
            saveResource("database.yml", false);
        }

        databaseFileConfig = new YamlConfiguration();
        try {
            databaseFileConfig.load(databaseFile);
        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
    }

    public static void reReadDatabase(JavaPlugin instance) {
        File databaseFile = new File(instance.getDataFolder(), "database.yml");
        databaseFileConfig = new YamlConfiguration();
        try {
            databaseFileConfig.load(databaseFile);
        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
    }

    public static void saveDatabase(JavaPlugin instance) {
        File databaseFile = new File(instance.getDataFolder(), "database.yml");
        try {
            databaseFileConfig.save(databaseFile);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static JavaPlugin getInstance() {
        return instance;
    }
    public static FileConfiguration getDatabase() {
        return databaseFileConfig;
    }

    @Override
    public void onDisable() {
        // Plugin shutdown logic
    }
}
